
(* name.ML *)

(* gives theorems appropriate names which could be used as input *)

infix 0 RS RSN RL RLN MRS MRL COMP;

(* name_thm : string * thm -> thm, names a theorem *)
val name_thm = Thm.name_thm ;

(* name_of_thm : thm -> string, gives name of a theorem *)
val name_of_thm = Thm.name_of_thm ;

(* no longer works or needed in Isabelle99, use definition given 
fun name_of_thm th = 
  let val {der = Join (hod, _), ...} = rep_thm th
    fun nd (Theorem name) = name
      | nd (Axiom name) = name (* 94-7: Axiom (_, name) *)
      | nd _ = ""
  in nd hod end ;
*)

(* simpnt : thm -> string, gives name of a theorem, omitting thyname. prefix *)
fun simpnt th = del2dot (name_of_thm th) ;

structure no_name = 
struct
val (op RS) = (op RS) ;
val (op MRS) = (op MRS) ;
val tn = tn ;
val tnr = tnr ;
val md1 = md1 ;
val md2 = md2 ;
val symmetric = symmetric ;
end ;

structure name = 
struct
fun th1 RS th2 = name_thm
  ("(" ^ simpnt th1 ^ " RS " ^ simpnt th2 ^ ")",
  no_name.RS (th1, th2)) ;
fun md1 th = name_thm ("(md1 " ^ simpnt th ^ ")", no_name.md1 th) ;
fun md2 th = name_thm ("(md2 " ^ simpnt th ^ ")", no_name.md2 th) ;
fun nthl thl = "[" ^ implode (separate ", " (map simpnt thl)) ^ "]" ;
fun thl MRS th = name_thm (
    "(" ^ nthl thl ^ " MRS " ^ simpnt th ^ ")", no_name.MRS (thl, th)) ;
fun tn thl = name_thm ("(tn " ^ nthl thl ^ ")", no_name.tn thl) ;
fun tnr thl = name_thm ("(tnr " ^ nthl thl ^ ")", no_name.tnr thl) ;
fun symmetric th = 
    name_thm ("(symmetric " ^ simpnt th ^ ")", no_name.symmetric th) ;
end ;
